﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Demo
{
    public class RfidMiddlec
    {
        Byte[] SndStr=new Byte[256];
        Byte[] Suppose=new Byte[1024];
        int[] len = new int[1];
        const Byte MI_OK = 0;
        const Byte MI_ERR = 1;
        CommonLowerc ALower;

        public RfidMiddlec()
        {
            ALower = new CommonLowerc();
        }

        public Byte SendPackageA(Byte Stx,Byte[] SndStrA,Byte[] Abuf,int[] len)
        {
            Byte[] buf=new Byte[1024];
            int i;
            if(ALower.SendPackage(Stx,SndStrA,buf,len)==MI_OK)
            {
                if (len[0] > 0)     //buf存放真正的数据
                    for (i = 0; i < (len[0]); i++)
                        Abuf[i] = buf[i];
//                        Move(&buf[2],Abuf,(len[0]-2));
                //return buf[0];
                return 0;
            }
            else
                return MI_ERR;
        }

        public int mopenport()
        {
        	return ALower.openport();
        }

        public void mcloseport()
        {
            ALower.closeport();
        }

        public bool Active()
        {
            return ALower.Active();
        }

        public Byte mifs_request(Byte mode,Byte[] TagType)
        {
        	SndStr[0]=0x41;
        	SndStr[1]=0x01;
        	SndStr[2]=mode;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,TagType,len);
        }

        public Byte mifs_Anticoll(Byte Bcnt,Byte[] SNR)
        {
        	SndStr[0]=0x42;
        	SndStr[1]=0x01;
        	SndStr[2]=Bcnt;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,SNR,len);
        }

        public Byte mifs_select(Byte[] Snr,Byte[] Size)
        {
            int i;
        	SndStr[0]=0x43;
        	SndStr[1]=0x04;
 //       	Move(Snr,&SndStr[2],4);
            for(i=0;i<4;i++)
                SndStr[2+i]=Snr[i];
        	len[0]= 6;
        	return SendPackageA(0x20,SndStr,Size,len);  //5 to be modified
        }

        public Byte mifs_Authentication(Byte Mode,Byte SecNr)
        {
        	SndStr[0]=0x44;
        	SndStr[1]=0x02;
        	SndStr[2]=Mode;
        	SndStr[3]=SecNr;
        	len[0]= 4;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_halt()
        {
        	SndStr[0]=0x45;
        	SndStr[1]=0x00;
        	len[0]= 2;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_Read(Byte Adr,Byte[] Data)
        {
        	SndStr[0]=0x46;
        	SndStr[1]=0x01;
	        SndStr[2]=Adr;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,Data,len);
        }

        public Byte mifs_Write(Byte Adr,Byte[] Data)
        {
            int i;
        	SndStr[0]=0x47;
        	SndStr[1]=0x11;
        	SndStr[2]=Adr;
            for (i = 0; i < 16; i++)
                SndStr[i + 3] = Data[i];
//        	Move(Data,&SndStr[3],16);
	        len[0]= 19;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_increment(Byte Adr,long Value)
        {
        	SndStr[0]=0x48;
        	SndStr[1]=0x05;
        	SndStr[2]=Adr;
            SndStr[3] = (Byte)(Value >> 8);
            SndStr[4] = (Byte)(Value - SndStr[3] * 0x100);
        	len[0]= 5;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_decrement(Byte Adr,long Value)
        {
        	SndStr[0]=0x49;
        	SndStr[1]=0x05;
        	SndStr[2]=Adr;
            SndStr[3] = (Byte)(Value >> 8);
            SndStr[4] = (Byte)(Value - SndStr[3] * 0x100);
        	len[0]= 5;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_restore(Byte Adr)
        {
        	SndStr[0]=0x4A;
        	SndStr[1]=0x01;
        	SndStr[2]=Adr;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_transfer(Byte Adr)
        {
        	SndStr[0]=0x4B;
        	SndStr[1]=0x01;
        	SndStr[2]=Adr;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_load_key(Byte Mode,Byte SecNr,Byte[] Nkey)
        {
            int i;
        	SndStr[0]=0x4C;
        	SndStr[1]=8;
        	SndStr[2]=Mode;
        	SndStr[3]=SecNr;
//        	Move(Nkey,&SndStr[4],6);
            for (i = 0; i < 6; i++)
                SndStr[i + 4] = Nkey[i];
        	len[0]= 10;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_reset(Byte Msec)
        {
        	SndStr[0]=0x4E;
        	SndStr[1]=0x01;
        	SndStr[2]=Msec;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_get_info(Byte[] Info)
        {
        	SndStr[0]=0x4F;
        	SndStr[1]=0x00;
        	len[0]= 2;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_set_control_bit()
        {
        	SndStr[0]=0x50;
        	SndStr[1]=0x00;
        	len[0]= 2;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_clr_control_bit()
        {
        	SndStr[0]=0x51;
        	SndStr[1]=0x00;
        	len[0]= 2;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_set_config()
        {
        	SndStr[0]=0x52;
        	SndStr[1]=0x00;
        	len[0]= 2;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_check_write(Byte[] Snr,Byte Authenmode,Byte Adr,Byte[] Data)
        {
        	int i;
        	SndStr[0]=0x53;
        	SndStr[1]=22;
//        	Move(Snr,&SndStr[2],4);
            for (i = 0; i < 4; i++)
                SndStr[i + 2] = Snr[i];
            SndStr[6] = Authenmode;
        	SndStr[7]=Adr;
//        	Move(Data,&SndStr[8],16);
            for (i = 0; i < 16; i++)
                SndStr[i + 8] = Data[i];
        	len[0]= 24;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_buzzer(Byte Frequence,Byte Opentm,Byte Closetm,Byte Repcnt)
        {
        	SndStr[0]=0x60;
        	SndStr[1]=0x04;
        	SndStr[2]=Frequence;
        	SndStr[3]=Opentm;
        	SndStr[4]=Closetm;
        	SndStr[5]=Repcnt;
        	len[0]= 6;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_read_E2(Byte Adr,Byte Lengthe,Byte[] Data)
        {
        	SndStr[0]=0x61;
        	SndStr[1]=0x02;
        	SndStr[2]=Adr;
        	SndStr[3]=Lengthe;
        	len[0]= 4;
        	return SendPackageA(0x20,SndStr,Data,len);
        }

        public Byte mifs_write_E2(Byte Adr,Byte Lengthe,Byte[] Data)
        {
            int i;
        	SndStr[0]=0x62;
        	SndStr[1]=(Byte)(Lengthe+2);
        	SndStr[2]=Adr;
        	SndStr[3]=Lengthe;
//        	Move(Data,&SndStr[4],Lengthe);
            for (i = 0; i < Lengthe; i++)
                SndStr[i + 4] = Data[i];
        	len[0]= Lengthe+4;
        	return SendPackageA(0x20,SndStr,Data,len);
        }

        public Byte mifs_close()
        {
        	SndStr[0]=0x3F;
        	SndStr[1]=0x00;
        	len[0]= 2;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_value(Byte mode,Byte Adr,long Value,Byte Trans_Adr)
        {
            long Tmp;
        	SndStr[0]=0x70;
        	SndStr[1]=0x07;
        	SndStr[2]=mode;
        	SndStr[3]=Adr;
        	SndStr[4]=(Byte)(Value>>24);
            Tmp = Value-SndStr[4]*0x1000000;
            SndStr[5] = (Byte)(Tmp >> 16); ;
            Tmp = Tmp - SndStr[5] * 0x10000;
            SndStr[6] = (Byte)(Tmp >> 8);
            SndStr[7] = (Byte)(Tmp - SndStr[6] * 0x100);
        	SndStr[8]=Trans_Adr;
	        len[0]= 9;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_Anticoll2(Byte Encoll,Byte Bcnt,Byte[] SNR)
        {
        	SndStr[0]=0x71;
        	SndStr[1]=0x02;
        	SndStr[2]=Encoll;
        	SndStr[3]=Bcnt;
        	len[0]= 4;
            return SendPackageA(0x20, SndStr, SNR, len);
        }

        public Byte mifs_Authentication2(Byte Mode,Byte SecNr,Byte KeyNr)
        {
        	SndStr[0]=0x72;
        	SndStr[1]=0x03;
        	SndStr[2]=Mode;
        	SndStr[3]=SecNr;
        	SndStr[4]=KeyNr;
        	len[0]= 5;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_Authentication3(Byte Mode,Byte SecNr,Byte[] Key)
        {
            int i;
            SndStr[0]=0x73;
        	SndStr[1]=0x08;
        	SndStr[2]=Mode;
        	SndStr[3]=SecNr;
//        	Move(Key,&SndStr[4],6);
            for (i = 0; i < 6; i++)
                SndStr[4 + i] = Key[i];
        	len[0]= 10;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_Cascanticoll(Byte Select_Code,Byte Bcnt,Byte[] SNR)
        {
        	SndStr[0]=0x74;
        	SndStr[1]=0x02;
        	SndStr[2]=Select_Code;
        	SndStr[3]=Bcnt;
        	len[0]= 4;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_Cascselect(Byte Select_Code,Byte[] Snr)
        {
            int i;
        	SndStr[0]=0x75;
        	SndStr[1]=0x05;
        	SndStr[2]=Select_Code;
//        	Move(Snr,&SndStr[3],4);
            for (i = 0; i < 4; i++)
                SndStr[3 + i] = Snr[i];
        	len[0]= 7;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_ULwrite(Byte Adr, Byte[] Data,Byte Sak)
        {
            int i;
    	    SndStr[0]=0x76;
    	    SndStr[1]=0x05;
    	    SndStr[2]=Adr;
//	        Move(Data,&SndStr[3],4);
            for (i = 0; i < 4; i++)
                SndStr[i + 3] = Data[i];
	        len[0]= 7;
	        return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_valueDebit(Byte mode,Byte Adr,long Value)
        {
            long Tmp;
        	SndStr[0]=0x77;
        	SndStr[1]=0x06;
        	SndStr[2]=mode;
        	SndStr[3]=Adr;
            SndStr[4] = (Byte)(Value >> 24);
            Tmp = Value - SndStr[4] * 0x1000000;
            SndStr[5] = (Byte)(Tmp >> 16); ;
            Tmp = Tmp - SndStr[5] * 0x10000;
            SndStr[6] = (Byte)(Tmp >> 8);
            SndStr[7] = (Byte)(Tmp - SndStr[6] * 0x100);
            len[0] = 8;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_write_reg(Byte Reg,Byte Value)
        {
        	SndStr[0]=0x3D;
        	SndStr[1]=0x02;
        	SndStr[2]=Reg;
        	SndStr[3]=Value;
        	len[0]= 4;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte mifs_read_reg(Byte Reg,Byte[] Value)
        {
        	SndStr[0]=0x3e;
        	SndStr[1]=0x01;
        	SndStr[2]=Reg;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte aclas_set_compass(Byte[] psw)
        {
            int i;
            SndStr[0]=0xB0;
        	SndStr[1]=0x08;
//        	Move(psw,&SndStr[2],8);
            for (i = 0; i < 8; i++)
                SndStr[2 + i] = psw[i];
        	len[0]= 10;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte aclas_set_bosspass(Byte[] psw)
        {
            SndStr[0] = 0xB1;
        /*	SndStr[1]=0x08;
        	Move(psw,&SndStr[2],8);
        	len[0]= 10;*/
        	SndStr[1]=0x01;
        	SndStr[2]=0x14;//Adr;
        	len[0]= 3;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte aclas_psw_auth(Byte Mode,Byte SecNr,Byte[] desCardno)
        {
            int i;
            SndStr[0]=0xB2;
        	SndStr[1]=0x0a;
        	SndStr[2]=Mode;
        	SndStr[3]=SecNr;
//        	Move(desCardno,&SndStr[4],8);
            for (i = 0; i < 8; i++)
                SndStr[4 + i] = desCardno[i];
        	len[0]= 12;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }

        public Byte aclas_auth_setkey(Byte SecNr,Byte[] desCardno)
        {
            int i;
            SndStr[0] = 0xB3;
        	SndStr[1]=0x09;
        	SndStr[2]=SecNr;
//        	Move(desCardno,&SndStr[3],8);
            for (i = 0; i < 8; i++)
                SndStr[3 + i] = desCardno[i];
            len[0] = 11;
        	return SendPackageA(0x20,SndStr,Suppose,len);
        }
    }
}
