﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Demo
{
    class des51
    {
        const int EN0 = 0;      //Encrpt
        const int DE1 = 1;      //Decrpt
        public struct des_ctx
        {
            public ulong[] ek;
            public ulong[] dk;
            public des_ctx(ulong i)
            {
                ek = new ulong[32];
                dk = new ulong[32];
            }
        }
        public des_ctx dc = new des_ctx(0);

        ulong[] KnL = { 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L };
        ulong[] KnR = { 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L };
        ulong[] Kn3 = { 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L, 0L };
        byte[] Df_Key = {
               0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef,
               0xfe,0xdc,0xba,0x98,0x76,0x54,0x32,0x10,
               0x89,0xab,0xcd,0xef,0x01,0x23,0x45,0x67 };

        ushort[] bytebit = {
                 128, 64, 32, 16, 8, 4, 2, 1};
        //              0200, 0100, 040, 020, 010, 04, 02, 01 };

        ulong[] bigbyte = {
               0x800000L,    0x400000L,     0x200000L,    0x100000L,
               0x80000L,     0x40000L,      0x20000L,     0x10000L,
               0x8000L,      0x4000L,       0x2000L,      0x1000L,
               0x800L,              0x400L,               0x200L,              0x100L,
               0x80L,               0x40L,                0x20L,               0x10L,
               0x8L,         0x4L,          0x2L,         0x1L   };

        /* Use the key schedule specified in the Standard (ANSI X3.92-1981). */

        byte[] pc1 = {
               56, 48, 40, 32, 24, 16,  8,   0, 57, 49, 41, 33, 25, 17,
                9,  1, 58, 50, 42, 34, 26,  18, 10,  2, 59, 51, 43, 35,
               62, 54, 46, 38, 30, 22, 14,   6, 61, 53, 45, 37, 29, 21,
               13,  5, 60, 52, 44, 36, 28,  20, 12,  4, 27, 19, 11,  3 };

        byte[] totrot = {
               1,2,4,6,8,10,12,14,15,17,19,21,23,25,27,28 };

        byte[] pc2 = {
               13, 16, 10, 23,  0,  4,       2, 27, 14,  5, 20,  9,
               22, 18, 11,  3, 25,  7,      15,  6, 26, 19, 12,  1,
               40, 51, 30, 36, 46, 54,      29, 39, 50, 44, 32, 47,
               43, 48, 38, 55, 33, 52,      45, 41, 49, 35, 28, 31 };

        private void deskey(byte[] key, short edf)
        {
            /* Thanks to James Gillogly & Phil Karn! */
            int i, j, l, m, n;    //register 
            byte[] pc1m = new byte[56];
            byte[] pcr = new byte[56];
            ulong[] kn = new ulong[32];

            for (j = 0; j < 56; j++)
            {
                l = pc1[j];
                m = l & 07;
                if ((key[l >> 3] & bytebit[m]) != 0)
                    pc1m[j] = 1;
                else
                    pc1m[j] = 0;
            }
            for (i = 0; i < 16; i++)
            {
                if (edf == DE1) m = (15 - i) << 1;
                else m = i << 1;
                n = m + 1;
                kn[m] = kn[n] = 0L;
                for (j = 0; j < 28; j++)
                {
                    l = j + totrot[i];
                    if (l < 28) pcr[j] = pc1m[l];
                    else pcr[j] = pc1m[l - 28];
                }
                for (j = 28; j < 56; j++)
                {
                    l = j + totrot[i];
                    if (l < 56) pcr[j] = pc1m[l];
                    else pcr[j] = pc1m[l - 28];
                }
                for (j = 0; j < 24; j++)
                {
                    if (pcr[pc2[j]] > 0) kn[m] |= bigbyte[j];
                    if (pcr[pc2[j + 24]] > 0) kn[n] |= bigbyte[j];
                }
            }
            cookey(kn);
        }

        private void memcpyz(int destindex, ulong[] dest, int srcindex, ulong[] srcb, int len)
        {
            int i;
            for (i = 0; i < len; i++)
                dest[i + destindex] = srcb[i + srcindex];
        }

        private void memcpyb(int destindex, byte[] dest, int srcindex, byte[] srcb, int len)
        {
            int i;
            for (i = 0; i < len; i++)
                dest[i + destindex] = srcb[i + srcindex];
        }

        private void cookey(ulong[] raw1)
        {
            ulong[] cook;
            ulong[] raw0 = new ulong[32];
            ulong[] dough = new ulong[32];
            int i, vr, vc;

            cook = dough;
            vr = 0;
            vc = 0;
            for (i = 0; i < 16; i++, vr++)
            {
                memcpyz(0, raw0, vr, raw1, 1);
                vr++;
                cook[vc] = (raw0[0] & 0x00fc0000L) << 6;
                cook[vc] |= (raw0[0] & 0x00000fc0L) << 10;
                cook[vc] |= (raw1[vr] & 0x00fc0000L) >> 10;
                cook[vc] |= (raw1[vr] & 0x00000fc0L) >> 6;
                vc++;
                cook[vc] = (raw0[0] & 0x0003f000L) << 12;
                cook[vc] |= (raw0[0] & 0x0000003fL) << 16;
                cook[vc] |= (raw1[vr] & 0x0003f000L) >> 4;
                cook[vc] |= (raw1[vr] & 0x0000003fL);
                vc++;
            }
            usekey(dough);
        }

        private void cpkey(ulong[] into)
        {
            /*ulong[] from, endp;

            from = KnL;
            endp = &KnL[32];
            while( from < endp ) *into++ = *from++;*/
            memcpyz(0, into, 0, KnL, 32);
        }

        private void usekey(ulong[] from)
        {
            /*ulong[] to, endp;

            to = KnL;
            endp = &KnL[32];
            while( to < endp ) *to++ = *from++;*/
            memcpyz(0, KnL, 0, from, 32);
        }

        /*#if 0
        void des(unsigned char *inblock, unsigned char *outblock)  {
          unsigned long work[2];

          scrunch(inblock, work);
          desfunc(work, KnL);
          unscrun(work, outblock);
        }
        #endif*/

        private void scrunch(byte[] outof, ulong[] into)
        {
            int vo, vf;
            vo = 0;
            vf = 0;
            into[vo] = (ulong)((outof[vf] & 0xffL) << 24);
            vf++;
            into[vo] |= (ulong)((outof[vf] & 0xffL) << 16);
            vf++;
            into[vo] |= (ulong)((outof[vf] & 0xffL) << 8);
            vf++;
            into[vo] |= (ulong)(outof[vf] & 0xffL);
            vf++;
            vo++;
            into[vo] = (ulong)((outof[vf] & 0xffL) << 24);
            vf++;
            into[vo] |= (ulong)((outof[vf] & 0xffL) << 16);
            vf++;
            into[vo] |= (ulong)((outof[vf] & 0xffL) << 8);
            vf++;
            into[vo] |= (ulong)(outof[vf] & 0xffL);
        }

        private void unscrun(ulong[] outof, byte[] into)
        {
            int vo, vf;
            vo = 0;
            vf = 0;
            into[vo] = (byte)((outof[vf] >> 24) & 0xffL);
            vo++;
            into[vo] = (byte)((outof[vf] >> 16) & 0xffL);
            vo++;
            into[vo] = (byte)((outof[vf] >> 8) & 0xffL);
            vo++;
            into[vo] = (byte)(outof[vf] & 0xffL);
            vo++;
            vf++;
            into[vo] = (byte)((outof[vf] >> 24) & 0xffL);
            vo++;
            into[vo] = (byte)((outof[vf] >> 16) & 0xffL);
            vo++;
            into[vo] = (byte)((outof[vf] >> 8) & 0xffL);
            vo++;
            into[vo] = (byte)(outof[vf] & 0xffL);
        }

        ulong[] SP1 = {
          0x01010400L, 0x00000000L, 0x00010000L, 0x01010404L,
          0x01010004L, 0x00010404L, 0x00000004L, 0x00010000L,
          0x00000400L, 0x01010400L, 0x01010404L, 0x00000400L,
          0x01000404L, 0x01010004L, 0x01000000L, 0x00000004L,
          0x00000404L, 0x01000400L, 0x01000400L, 0x00010400L,
          0x00010400L, 0x01010000L, 0x01010000L, 0x01000404L,
          0x00010004L, 0x01000004L, 0x01000004L, 0x00010004L,
          0x00000000L, 0x00000404L, 0x00010404L, 0x01000000L,
          0x00010000L, 0x01010404L, 0x00000004L, 0x01010000L,
          0x01010400L, 0x01000000L, 0x01000000L, 0x00000400L,
          0x01010004L, 0x00010000L, 0x00010400L, 0x01000004L,
          0x00000400L, 0x00000004L, 0x01000404L, 0x00010404L,
          0x01010404L, 0x00010004L, 0x01010000L, 0x01000404L,
          0x01000004L, 0x00000404L, 0x00010404L, 0x01010400L,
          0x00000404L, 0x01000400L, 0x01000400L, 0x00000000L,
          0x00010004L, 0x00010400L, 0x00000000L, 0x01010004L };

        ulong[] SP2 = {
          0x80108020L, 0x80008000L, 0x00008000L, 0x00108020L,
          0x00100000L, 0x00000020L, 0x80100020L, 0x80008020L,
          0x80000020L, 0x80108020L, 0x80108000L, 0x80000000L,
          0x80008000L, 0x00100000L, 0x00000020L, 0x80100020L,
          0x00108000L, 0x00100020L, 0x80008020L, 0x00000000L,
          0x80000000L, 0x00008000L, 0x00108020L, 0x80100000L,
          0x00100020L, 0x80000020L, 0x00000000L, 0x00108000L,
          0x00008020L, 0x80108000L, 0x80100000L, 0x00008020L,
          0x00000000L, 0x00108020L, 0x80100020L, 0x00100000L,
          0x80008020L, 0x80100000L, 0x80108000L, 0x00008000L,
          0x80100000L, 0x80008000L, 0x00000020L, 0x80108020L,
          0x00108020L, 0x00000020L, 0x00008000L, 0x80000000L,
          0x00008020L, 0x80108000L, 0x00100000L, 0x80000020L,
          0x00100020L, 0x80008020L, 0x80000020L, 0x00100020L,
          0x00108000L, 0x00000000L, 0x80008000L, 0x00008020L,
          0x80000000L, 0x80100020L, 0x80108020L, 0x00108000L };

        ulong[] SP3 = {
          0x00000208L, 0x08020200L, 0x00000000L, 0x08020008L,
          0x08000200L, 0x00000000L, 0x00020208L, 0x08000200L,
          0x00020008L, 0x08000008L, 0x08000008L, 0x00020000L,
          0x08020208L, 0x00020008L, 0x08020000L, 0x00000208L,
          0x08000000L, 0x00000008L, 0x08020200L, 0x00000200L,
          0x00020200L, 0x08020000L, 0x08020008L, 0x00020208L,
          0x08000208L, 0x00020200L, 0x00020000L, 0x08000208L,
          0x00000008L, 0x08020208L, 0x00000200L, 0x08000000L,
          0x08020200L, 0x08000000L, 0x00020008L, 0x00000208L,
          0x00020000L, 0x08020200L, 0x08000200L, 0x00000000L,
          0x00000200L, 0x00020008L, 0x08020208L, 0x08000200L,
          0x08000008L, 0x00000200L, 0x00000000L, 0x08020008L,
          0x08000208L, 0x00020000L, 0x08000000L, 0x08020208L,
          0x00000008L, 0x00020208L, 0x00020200L, 0x08000008L,
          0x08020000L, 0x08000208L, 0x00000208L, 0x08020000L,
          0x00020208L, 0x00000008L, 0x08020008L, 0x00020200L };

        ulong[] SP4 = {
          0x00802001L, 0x00002081L, 0x00002081L, 0x00000080L,
          0x00802080L, 0x00800081L, 0x00800001L, 0x00002001L,
          0x00000000L, 0x00802000L, 0x00802000L, 0x00802081L,
          0x00000081L, 0x00000000L, 0x00800080L, 0x00800001L,
          0x00000001L, 0x00002000L, 0x00800000L, 0x00802001L,
          0x00000080L, 0x00800000L, 0x00002001L, 0x00002080L,
          0x00800081L, 0x00000001L, 0x00002080L, 0x00800080L,
          0x00002000L, 0x00802080L, 0x00802081L, 0x00000081L,
          0x00800080L, 0x00800001L, 0x00802000L, 0x00802081L,
          0x00000081L, 0x00000000L, 0x00000000L, 0x00802000L,
          0x00002080L, 0x00800080L, 0x00800081L, 0x00000001L,
          0x00802001L, 0x00002081L, 0x00002081L, 0x00000080L,
          0x00802081L, 0x00000081L, 0x00000001L, 0x00002000L,
          0x00800001L, 0x00002001L, 0x00802080L, 0x00800081L,
          0x00002001L, 0x00002080L, 0x00800000L, 0x00802001L,
          0x00000080L, 0x00800000L, 0x00002000L, 0x00802080L };

        ulong[] SP5 = {
          0x00000100L, 0x02080100L, 0x02080000L, 0x42000100L,
          0x00080000L, 0x00000100L, 0x40000000L, 0x02080000L,
          0x40080100L, 0x00080000L, 0x02000100L, 0x40080100L,
          0x42000100L, 0x42080000L, 0x00080100L, 0x40000000L,
          0x02000000L, 0x40080000L, 0x40080000L, 0x00000000L,
          0x40000100L, 0x42080100L, 0x42080100L, 0x02000100L,
          0x42080000L, 0x40000100L, 0x00000000L, 0x42000000L,
          0x02080100L, 0x02000000L, 0x42000000L, 0x00080100L,
          0x00080000L, 0x42000100L, 0x00000100L, 0x02000000L,
          0x40000000L, 0x02080000L, 0x42000100L, 0x40080100L,
          0x02000100L, 0x40000000L, 0x42080000L, 0x02080100L,
          0x40080100L, 0x00000100L, 0x02000000L, 0x42080000L,
          0x42080100L, 0x00080100L, 0x42000000L, 0x42080100L,
          0x02080000L, 0x00000000L, 0x40080000L, 0x42000000L,
          0x00080100L, 0x02000100L, 0x40000100L, 0x00080000L,
          0x00000000L, 0x40080000L, 0x02080100L, 0x40000100L };

        ulong[] SP6 = {
          0x20000010L, 0x20400000L, 0x00004000L, 0x20404010L,
          0x20400000L, 0x00000010L, 0x20404010L, 0x00400000L,
          0x20004000L, 0x00404010L, 0x00400000L, 0x20000010L,
          0x00400010L, 0x20004000L, 0x20000000L, 0x00004010L,
          0x00000000L, 0x00400010L, 0x20004010L, 0x00004000L,
          0x00404000L, 0x20004010L, 0x00000010L, 0x20400010L,
          0x20400010L, 0x00000000L, 0x00404010L, 0x20404000L,
          0x00004010L, 0x00404000L, 0x20404000L, 0x20000000L,
          0x20004000L, 0x00000010L, 0x20400010L, 0x00404000L,
          0x20404010L, 0x00400000L, 0x00004010L, 0x20000010L,
          0x00400000L, 0x20004000L, 0x20000000L, 0x00004010L,
          0x20000010L, 0x20404010L, 0x00404000L, 0x20400000L,
          0x00404010L, 0x20404000L, 0x00000000L, 0x20400010L,
          0x00000010L, 0x00004000L, 0x20400000L, 0x00404010L,
          0x00004000L, 0x00400010L, 0x20004010L, 0x00000000L,
          0x20404000L, 0x20000000L, 0x00400010L, 0x20004010L };

        ulong[] SP7 = {
          0x00200000L, 0x04200002L, 0x04000802L, 0x00000000L,
          0x00000800L, 0x04000802L, 0x00200802L, 0x04200800L,
          0x04200802L, 0x00200000L, 0x00000000L, 0x04000002L,
          0x00000002L, 0x04000000L, 0x04200002L, 0x00000802L,
          0x04000800L, 0x00200802L, 0x00200002L, 0x04000800L,
          0x04000002L, 0x04200000L, 0x04200800L, 0x00200002L,
          0x04200000L, 0x00000800L, 0x00000802L, 0x04200802L,
          0x00200800L, 0x00000002L, 0x04000000L, 0x00200800L,
          0x04000000L, 0x00200800L, 0x00200000L, 0x04000802L,
          0x04000802L, 0x04200002L, 0x04200002L, 0x00000002L,
          0x00200002L, 0x04000000L, 0x04000800L, 0x00200000L,
          0x04200800L, 0x00000802L, 0x00200802L, 0x04200800L,
          0x00000802L, 0x04000002L, 0x04200802L, 0x04200000L,
          0x00200800L, 0x00000000L, 0x00000002L, 0x04200802L,
          0x00000000L, 0x00200802L, 0x04200000L, 0x00000800L,
          0x04000002L, 0x04000800L, 0x00000800L, 0x00200002L };

        ulong[] SP8 = {
          0x10001040L, 0x00001000L, 0x00040000L, 0x10041040L,
          0x10000000L, 0x10001040L, 0x00000040L, 0x10000000L,
          0x00040040L, 0x10040000L, 0x10041040L, 0x00041000L,
          0x10041000L, 0x00041040L, 0x00001000L, 0x00000040L,
          0x10040000L, 0x10000040L, 0x10001000L, 0x00001040L,
          0x00041000L, 0x00040040L, 0x10040040L, 0x10041000L,
          0x00001040L, 0x00000000L, 0x00000000L, 0x10040040L,
          0x10000040L, 0x10001000L, 0x00041040L, 0x00040000L,
          0x00041040L, 0x00040000L, 0x10041000L, 0x00001000L,
          0x00000040L, 0x10040040L, 0x00001000L, 0x00041040L,
          0x10001000L, 0x00000040L, 0x10000040L, 0x10040000L,
          0x10040040L, 0x10000000L, 0x00040000L, 0x10001040L,
          0x00000000L, 0x10041040L, 0x00040040L, 0x10000040L,
          0x10040000L, 0x10001000L, 0x10001040L, 0x00000000L,
          0x10041040L, 0x00041000L, 0x00041000L, 0x00001040L,
          0x00001040L, 0x00040040L, 0x10000000L, 0x10041000L };

        private void desfunc(ulong[] block, ulong[] keys)
        {
            ulong fval, work, right, leftt;
            int round, vk;

            leftt = block[0];
            right = block[1];
            work = ((leftt >> 4) ^ right) & 0x0f0f0f0fL;
            right ^= work;
            leftt ^= (work << 4);
            work = ((leftt >> 16) ^ right) & 0x0000ffffL;
            right ^= work;
            leftt ^= (work << 16);
            work = ((right >> 2) ^ leftt) & 0x33333333L;
            leftt ^= work;
            right ^= (work << 2);
            work = ((right >> 8) ^ leftt) & 0x00ff00ffL;
            leftt ^= work;
            right ^= (work << 8);
            right = ((right << 1) | ((right >> 31) & 1L)) & 0xffffffffL;
            work = (leftt ^ right) & 0xaaaaaaaaL;
            leftt ^= work;
            right ^= work;
            leftt = ((leftt << 1) | ((leftt >> 31) & 1L)) & 0xffffffffL;

            vk = 0;
            for (round = 0; round < 8; round++)
            {
                work = (right << 28) | (right >> 4);
                work ^= keys[vk];//*keys++;
                vk++;
                fval = SP7[work & 0x3fL];
                fval |= SP5[(work >> 8) & 0x3fL];
                fval |= SP3[(work >> 16) & 0x3fL];
                fval |= SP1[(work >> 24) & 0x3fL];
                work = right ^ keys[vk];// *keys++;
                vk++;
                fval |= SP8[work & 0x3fL];
                fval |= SP6[(work >> 8) & 0x3fL];
                fval |= SP4[(work >> 16) & 0x3fL];
                fval |= SP2[(work >> 24) & 0x3fL];
                leftt ^= fval;
                work = (leftt << 28) | (leftt >> 4);
                work ^= keys[vk];// *keys++;
                vk++;
                fval = SP7[work & 0x3fL];
                fval |= SP5[(work >> 8) & 0x3fL];
                fval |= SP3[(work >> 16) & 0x3fL];
                fval |= SP1[(work >> 24) & 0x3fL];
                work = leftt ^ keys[vk];// *keys++;
                vk++;
                fval |= SP8[work & 0x3fL];
                fval |= SP6[(work >> 8) & 0x3fL];
                fval |= SP4[(work >> 16) & 0x3fL];
                fval |= SP2[(work >> 24) & 0x3fL];
                right ^= fval;
            }

            right = (right << 31) | (right >> 1);
            work = (leftt ^ right) & 0xaaaaaaaaL;
            leftt ^= work;
            right ^= work;
            leftt = (leftt << 31) | (leftt >> 1);
            work = ((leftt >> 8) ^ right) & 0x00ff00ffL;
            right ^= work;
            leftt ^= (work << 8);
            work = ((leftt >> 2) ^ right) & 0x33333333L;
            right ^= work;
            leftt ^= (work << 2);
            work = ((right >> 16) ^ leftt) & 0x0000ffffL;
            leftt ^= work;
            right ^= (work << 16);
            work = ((right >> 4) ^ leftt) & 0x0f0f0f0fL;
            leftt ^= work;
            right ^= (work << 4);
            //  *block++ = right;
            //  *block = leftt;
            block[0] = right;
            block[1] = leftt;
        }

        /* Validation sets:
         *
         * Single-length key, single-length plaintext -
         * Key    : 0123 4567 89ab cdef
         * Plain  : 0123 4567 89ab cde7
         * Cipher : c957 4425 6a5e d31d
         *
         **********************************************************************/

        public void des_key(des_ctx dc, byte[] key)
        {
            deskey(key, EN0);
            cpkey(dc.ek);
            //            MessageBox.Show("dsKeyEn" + dc.ek[0].ToString() + "," + dc.ek[1].ToString() + "," + dc.ek[2].ToString() + "," + dc.ek[3].ToString());
            deskey(key, DE1);
            cpkey(dc.dk);
        }

        /* Encrypt several blocks in ECB mode.  Caller is responsible for
           short blocks. */
        public void des_enc(des_ctx dc, byte[] Data, int blocks)
        {
            ulong[] work = new ulong[2];
            int i;
            byte[] cp = new byte[8];

            if (blocks > 1) return;
            memcpyb(0, cp, 0, Data, 8);
            for (i = 0; i < blocks; i++)
            {
                scrunch(cp, work);
                desfunc(work, dc.ek);
                unscrun(work, cp);
            }
            memcpyb(0, Data, 0, cp, 8);
        }

        public void des_dec(des_ctx dc, byte[] Data, int blocks)
        {
            ulong[] work = new ulong[2];
            int i;
            byte[] cp = new byte[8];

            if (blocks > 1) return;
            memcpyb(0, cp, 0, Data, 8);
            for (i = 0; i < blocks; i++)
            {
                scrunch(cp, work);
                desfunc(work, dc.dk);
                unscrun(work, cp);
            }
            memcpyb(0, Data, 0, cp, 8);
        }

    }
}
