﻿using System;
using System.Windows.Forms;
using ACLAS;

namespace GPRSPowerControlDemo
{
    public partial class Form1 : Form
    {
        //  Use Aclas Lib
        private PowerClass pwr = new PowerClass();

        public Form1()
        {
            InitializeComponent();
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btOn_Click(object sender, EventArgs e)
        {
            // Turn On
            pwr.GPRSPowerControlOn();
        }

        private void btOff_Click(object sender, EventArgs e)
        {
            // Turn Off
            pwr.GPRSPowerControlOff();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Open Power Driver
            if (!pwr.Open())
            {
                MessageBox.Show("Open Power Driver Error!");
                Close();
            }
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            // Close Power Driver
            pwr.Close();
        }
    }
}