﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TestBuzzer
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// The commands of buzz,
        /// 4 UInt16 one group:
        /// 1st is buzz times
        /// 2nd is frequency
        /// 3rd is duration time(ms)
        /// 4th is pause time(ms)
        /// </summary>
        private static UInt16[] Commands =
        {
           //1 time, 2000 frequency, 80 duration time, 40 pause time
           1 , 2000, 80 , 40, 
           //2 times, 3000 frequency, 80 duration time, 40 pause time
           2 , 3000, 80 , 40,
           //3 times, 4000 frequency, 80 duration time, 40 pause time
           3 , 4000, 80 , 40
        };


        public Form1()
        {
            InitializeComponent();

            //Open the buzzer
            ACLAS.Buzzer.Open();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ACLAS.Buzzer.SoundOut(Commands);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            ACLAS.Buzzer.Close();
        }

    }
}